structure Color :> COLOR =
  struct
    type color = {r:Word8.word,g:Word8.word,b:Word8.word}


    fun fromRGB {r,g,b} = let
      fun r2w r = Word8.fromInt(Real.trunc(255.0*r))
    in {r=r2w r,g=r2w g,b=r2w b}
    end
    fun toRGB ({r,g,b}:color) = let
      fun w2r n = (Real.fromInt(Word8.toInt n))/255.0
    in {r=w2r r,g=w2r g,b=w2r b}
    end
    fun toRGB24 c = c


    fun s2w s w = let
      val r = Real.fromInt(Word8.toInt w)
    in Word8.fromInt(Real.trunc(s*r))
    end

    val red = fromRGB{r=1.0,g=0.0,b=0.0}
    val green = fromRGB{r=0.0,g=1.0,b=0.0}
    val blue = fromRGB{r=0.0,g=0.0,b=1.0}
    val cyan = fromRGB{r=0.0,g=1.0,b=1.0}
    val magenta = fromRGB{r=1.0,g=0.0,b=1.0}
    val yellow = fromRGB{r=1.0,g=1.0,b=0.0}
    val white = fromRGB{r=1.0,g=1.0,b=1.0}
    val black = fromRGB{r=0.0,g=0.0,b=0.0}

    fun scale(s,{r,g,b}:color) = {r=s2w s r,g=s2w s g,b=s2w s b}
    val cb = [0wx00:Word8.word,0wx33,0wx66,0wx99,0wxCC,0wxFF]
    fun comb c xs = List.foldr (fn (x,xs) =>
				List.foldr (fn (c,xs) => (c,x)::xs) xs c)
                               [] xs

    val cube = comb cb (comb cb cb)
    val pallet = 
      Vector.fromList (List.map (fn (g,(b,r)) => {r=r,g=g,b=b}) cube)
    fun from216 i = Vector.sub(pallet,i)
    val eq: (color * color) -> bool = (op =)
  end