signature CONVERT = sig
  type area = {ll:(real * real),
	       ur:(real * real),
	       dpi:real}
  type image = {bg:Color.color,
	        fg:(real * real) -> Color.color option}
  type shape = (real * real) -> bool
  val toPBM : area -> BinIO.outstream -> shape -> unit
  val toPPM : area -> BinIO.outstream -> image -> unit

  val toBWPNG   : area -> shape -> string -> unit
  val toRGBPNG  : area -> image -> string -> unit
  val toPS      : area -> image -> string -> unit
  val toASCII   : area -> image -> unit
  val display   : area -> image -> unit
end