structure Geometry :> GEOMETRY =
  struct
    type point = (real * real)
    type vect = (point * point)
    val origin = (0.0,0.0)
    fun plusPt((x1,y1):point,(x2,y2)) = (x1 + x2,y1 + y2)
    fun minusPt((x1,y1):point,(x2,y2)) = (x1 - x2,y1 - y2)
    fun scaleXY((x1,y1):point,(x2,y2)) = (x1 * x2,y1 * y2)
    fun dotProd((x1,y1):point,(x2,y2)) = x1*x2 + y1*y2
    fun distSquared (p,q) = let 
      val diff = minusPt(p,q)
    in dotProd(diff,diff)
    end
    fun leftOf ((x0,y0):point,(x1,y1):point) = let
      val k1 = (x1-x0)
      val k2 = (y1-y0)
      val k3 = k1*y0 - k2*x0
      fun f (x2,y2) = (k1*y2) >= ((k2*x2) + k3)
    in f
    end
    fun projectPt ((x1,y1):point,(x2,y2):point)= let
      val dsquared = distSquared((x1,y1),(x2,y2))
      val dx = x2 - x1
      val dy = y2 - y1
      val k = y1*dy + x1*dx
      fun f ((x3,y3):point) = (x3*dx  + y3*dy - k)/dsquared
    in f
    end
  end