structure Picture :> PICTURE =
  struct
    open Geometry
    type pict = (point -> Color.color option)
    datatype pict_def =
      Layer of Texture.texture_def * Shape.shape_def
    | OnTop of pict_def * pict_def
    fun mkPict (Layer (t,s)) = let
      val s = Shape.mkShape s
      val t = Texture.mkTexture t
      fun f p =
	if Shape.member s p then
	  SOME (Texture.getColor t p)
	else NONE
    in f
    end
      | mkPict (OnTop(p1,p2)) = let
         val p1 = mkPict p1
         val p2 = mkPict p2
	  fun f p = 
	    (case p1 p of
	       NONE => p2 p
	     | SOME c => (SOME c))
	in f
	end
    fun getPixel p = p
  end