signature SHAPE = sig
    type shape
    datatype shape_def =
      Everything
    | Nothing
    | Elipse     of Geometry.point * real * real
    | HalfPlane  of Geometry.point * Geometry.point 
    | Intersect  of shape_def * shape_def
    | Union      of shape_def * shape_def
    | Diff       of shape_def * shape_def
    | Trans      of Geometry.point * shape_def
    | ScaleXY    of real * real * shape_def

    val optimize     : bool ref
    val remove_trans : shape_def -> shape_def
    val remove_scale : shape_def -> shape_def
    val mkShape : shape_def -> shape
    val member : shape -> (Geometry.point -> bool)
  end